<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>
  </head>
  <body></body>
</html>

<script>
  class Product {
    _name;
    _price;
    _numberOfCopies;

    constructor(paramName, paramPrice, paramNumberOfCopies) {
      this._name = paramName;
      this._price = paramPrice;
      this._numberOfCopies = paramNumberOfCopies;
    }

    sellCopies() {
      console.log("Sell copies of " + this._name);
    }

    orderCopies() {
      console.log("Order copies of " + this._name);
    }
  }

  class Album extends Product {
    _artist;

    constructor(paramName, paramPrice, paramNumberOfCopies, paramArtist) {
      super(paramName, paramPrice, paramNumberOfCopies);
      this._artist = paramArtist;
    }
  }

  class Movie extends Product {
    _director;

    constructor(paramName, paramPrice, paramNumberOfCopies, paramDirector) {
      super(paramName, paramPrice, paramNumberOfCopies);
      this._director = paramDirector;
    }
  }

  var vProduct = new Product("Product1", 20, 10);
  console.log(vProduct);
  vProduct.sellCopies();
  vProduct.orderCopies();
  console.log(vProduct instanceof Product);

  console.log("--------------------------");
  var vAlbum1 = new Album("Product2", 30, 15, "Artist1");
  console.log(vAlbum1);
  vAlbum1.sellCopies();
  vAlbum1.orderCopies();
  console.log(vAlbum1 instanceof Album);
  console.log(vAlbum1 instanceof Product);

  console.log("--------------------------");
  var vMovie1 = new Movie("Product3", 50, 20, "Director1");
  console.log(vMovie1);
  vMovie1.sellCopies();
  vMovie1.orderCopies();
  console.log(vMovie1 instanceof Movie);
  console.log(vMovie1 instanceof Product);
</script>
